#ifndef JAZZ_ALL_H
#define JAZZ_ALL_H

#include "movegen.h"
#include "board.h"
#include "game.h"
#include "hashtable.h"
#include "fen.h"
#include "computer.h"
#include "alphabeta.h"
#include "evaluate.h"
#include "timer.h"
#include "names.h"
#include "genrand.h"
#include "movestring.h"
#include "book.h"
#include "heuristic.h"
#include "egtb.h"
#include "smp.h"

/* Initialise all Jazz components */
static inline void initialise_jazz(void)
{
   playgame_init();
   construct_inverse_diagonal_maps();
   generate_movement_tables();
   initialise_evaluation();
}

#endif
